
/* support.c
   (C) 2011,2017,2020 Yann Guidon whygee@f-cpu.org
   The source code of this project is released under the AGPLv3 or later,
   see https://www.gnu.org/licenses/agpl-3.0.en.html

version 20200415: split from HTTaP.h & .c,
  added some portability and simplified some parts
version 20200425: cleanup for the new code structure.

 */


/* A wrapper to prevent empty environment variables
   from being registered as valid */
void *my_getenv(char *s) {
  s=getenv(s);
  if (s && s[0])
    return s;
  return NULL;
}

/* Display an error message, with optional perror */
void show_exit(char *msg, int perr) {
  fflush(NULL);
  if (perr)
    perror(msg);
  else
    printf(msg);
  exit(EXIT_FAILURE);
}

//////////////// Some signal functions, not used yet ////////////////

#ifdef HTTAP_USE_SIGNAL

// hook for all the signals
void interrupt_program(int sig) {
  printf("\n Received signal %d\n", sig);
  abort_program=1; // raise a flag
}

// Register all the relevant signals to stop the program
void intercept_signals() {
  signal(SIGHUP,  interrupt_program);
  signal(SIGINT,  interrupt_program);
  signal(SIGQUIT, interrupt_program);
  signal(SIGSTOP, interrupt_program);
  signal(SIGTERM, interrupt_program);
  signal(SIGABRT, interrupt_program);
  signal(SIGKILL, interrupt_program);
}

#endif
