/* support.h
   (C) 2011,2017,2020 Yann Guidon whygee@f-cpu.org
   The source code of this project is released under the AGPLv3 or later,
   see https://www.gnu.org/licenses/agpl-3.0.en.html

version 20200415: split from HTTaP.h

This file includes standard libraries and some portability symbols.
You can configure the parameters in HTTaP.h.
 */

#ifndef SUPPORT_H
#define SUPPORT_H

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <sys/types.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <pwd.h>
#include <grp.h>
#include <sys/stat.h>
#include <signal.h>
#include <sys/time.h>
#include <time.h>

// define __sighandler_t on MacOSX/xBSD:
#ifndef __sighandler_t
#define __sighandler_t sig_t
#endif

#ifdef HTTAP_VERBOSE
#define VERBOSE_PRINTF(...) printf( __VA_ARGS__)
#else
#define VERBOSE_PRINTF(...) /* do nothing */
#endif

#endif
