/* ygtcpip.h
   (C) 2011,2017,2020 Yann Guidon whygee@f-cpu.org
   The source code of this project is released under the AGPLv3 or later,
   see https://www.gnu.org/licenses/agpl-3.0.en.html

version 20200415: split from HTTaP.h

This file includes standard libraries and some portability symbols.
You can configure the parameters in HTTaP.h.
 */

#ifndef YGTCPIP_H
#define YGTCPIP_H

#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <netdb.h>
#include <netinet/tcp.h>

// Some platform abstraction:
// POSIX definitions:
#define closesocket(x)  close(x)
#define SOCKET_TYPE int
#define net_perror(x)  perror(x)
#define LastSockError(x) errno
#define INVALID_SOCKET (-1)
#define SOCKET_ERROR  (-1)
#define INPROGRESS EINPROGRESS
#define INTR       EINTR

#endif
